<template>
  <div class="camerasMg">
    <el-row class="topBar">
      <el-col>
        <el-form :inline="true" :model="searchData">
          <el-form-item label>
            <el-input v-model="searchData.deviceName" placeholder="请输设备名称名"></el-input>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="searchFun()">
              <i class="el-icon-search"></i> 搜索
            </el-button>
            <el-button type="primary" @click="resetFun()">
              <i class="el-icon-refresh"></i> 重置
            </el-button>
          </el-form-item>
          <el-form-item class="fr">
            <el-button plain type="primary" @click="addFun()">
              <i class="el-icon-plus"></i> 新增
            </el-button>
          </el-form-item>
        </el-form>
      </el-col>
    </el-row>
    <el-table
      :data="tableData.pageData"
      stripe
      border
      style="width:100%;"
      :loading="false"
    >
      <el-table-column width="50" type="index" label="序号"></el-table-column>
      <el-table-column prop="deviceName" label="设备名称"></el-table-column>
      <el-table-column prop="deviceType" label="设备类型"></el-table-column>
      <el-table-column prop="deviceNo" label="设备编号"></el-table-column>
      <el-table-column prop="address" label="安装地址"></el-table-column>
      <el-table-column label="经纬度">
        <template slot-scope="scope">
          <font v-if="scope.row.longitude != null">{{'[' + scope.row.longitude + ',' + scope.row.latitude + ']'}}</font>
        </template>
      </el-table-column>
      <el-table-column prop="createTime" label="创建时间"></el-table-column>
      <el-table-column label="操作" width="150">
        <template slot-scope="scope">
          <el-button @click="editFun(scope.row)" size="small">编辑</el-button>
          <el-button type="danger" @click="delFun(scope.row)" size="small">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      background
      layout="total,sizes, prev, pager, next, jumper"
      :total="tableData.total"
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange"
      :current-page="PAGE.page"
      :page-size="PAGE.size"
    ></el-pagination>
    <SensorMgEdit v-if="dialogVisible"
      :dialogVisible="dialogVisible"
      :editForm="formData"
      :title="dialogTit"
      @dialogFun="closeDialog"
      @refreshTableData="getTableData"
      :key="zjKey"
    ></SensorMgEdit>
  </div>
</template>
<script lang="ts">
import { Component, Vue, Provide } from "vue-property-decorator";
import SensorMgEdit from "./SensorMgEdit.vue";
import METHOD from "@/utils/methods";
@Component({
  components: { SensorMgEdit }
})
export default class SensorMg extends Vue {
  @Provide() tableData: Object = { pageData: [], total: 0 };
  @Provide() PAGE: any = { page: 1, size: 10 };
  @Provide() searchData: any = { deviceName: "" };
  @Provide() loading: Boolean = false;
  //编辑组件
  @Provide() dialogVisible: Boolean = false;
  @Provide() dialogTit: String = "新增";
  @Provide() formData: Object = {};
  @Provide() zjKey:any = 0;
  @Provide() qvvalue:any = [];
  getTableData() {
    let that = this,
    param = Object.assign({}, that.searchData, that.PAGE);
    (this as any).$axios
      .post(`/zhDeviceInfo/getZHDeviceInfoList/`, param)
      .then((res: any) => {
        that.tableData = res;
      });
  }
  searchFun() {
    this.PAGE = { page: 1, size: 10 };
    this.getTableData();
  }
  resetFun() {
    this.PAGE = { page: 1, size: 10 };
    this.searchData.deviceName = "";
    this.getTableData();
  }
  addFun() {
    this.zjKey++;
    this.qvvalue = [];
    this.dialogVisible = true;
  }
  editFun(row: any) {
    this.dialogTit = "编辑";
    this.formData = Object.assign({},row);
    this.zjKey++;
    let arr = []
    arr.push(row.provinceId);
    arr.push(row.cityId);
    arr.push(row.countyId);
    this.qvvalue = [...arr]
    this.dialogVisible = true;
  }
  delFun(row: any) {
    let that = this as any;
    METHOD.deleteFun(
      this,
      `/zhDeviceInfo/delZHDeviceInfoById/${row.id}`,
      function() {
        that.getTableData();
      }
    );
  }
  handleSizeChange(val: any) {
    this.PAGE.size = val;
    this.getTableData()
  }
  handleCurrentChange(val: any) {
    this.PAGE.page = val;
    this.getTableData()
  }
  closeDialog() {
    //关闭窗口
    this.dialogVisible = false;
    this.formData = {};
  }
  created() {
    this.getTableData();
  }
}
</script>
